
;******************************************************}
;                                                      }
;       Brainf*ck compiler                             }
;       Written by Y [20-01-03], [26-01-03]            }
;                                                      }
;       Copyright (c) 2003 YALLIE, Inc.                }
;       All Rights Reserved                            }
;                                                      }
;******************************************************}

; Host and target platform: 16-bit DOS (COM file)
; Code size: 161 bytes (UPX-safe version - 163 bytes)

; Assemble: tasm bfc.asm /m3
; UPX-safe: tasm bfc.asm /m3 /dUPX_SAFE
; Link:     tlink bfc.obj /t /x

        .model  tiny
        .code
        org     100h
        locals  @@

        include bfc.inc

Start:  Initialize

        LEA     SI, [DI + 1]            ; output buffer offset
        PUSH    SI                      ; save it

;       LEA     BX, (offset BF_InitProgram - 100h) ; = 0
;                                       ; BX should be zero at this point
        MOV     CL, BF_InitProgramSize
        CALL    MoveData

;       INC     byte ptr [DI]           ; While loop starting condition
;       CALL    StatementList
        CALL    StatementList_Hack      ; skip starting condition check
        
        POP     DI                      ; restore buffer offset in DI

  OutputData:

        OutputSymbol

        INC     DI
        CMP     DI, SI
        JNE     OutputData

        RET

; BF grammar:

; Program -> StatementList
; StatementList -> { Statement }
; Statement -> ">" | "<" | "+" | "-" | "." | ","
;           -> "[" StatementList "]"
        
StatementList proc near

@@MainLoop:
        
        WhileLoop @@AfterLoop

        InputSymbol

        ; at this point, AX = 1 (if no I/O errors), so AH = 0

        MOV     AL, [DI]

  @@CaseGreater:
        MOV     byte ptr [SI], 047h     ; opcode for "INC DI"
        CMP     AL, '>'                 ; increase pointer
        JNE     @@CaseLess
        INC     SI
        RET
  @@CaseLess:
        CMP     AL, '<'                 ; decrease pointer
        JNE     @@CasePlus
;       MOV     byte ptr [SI], 04Fh     ; opcode for "DEC DI"
    @@Add08IncSiRet:
        ADD     byte ptr [SI], 08h      ; 04Fh-047h = 0FE0Dh-0FE05h = 08h
        INC     SI
        RET
  @@CasePlus:
        MOV     word ptr [SI], 005FEh   ; opcode for "INC byte ptr [DI]"
;       CMP     AL, '+'                 ; increase byte
        SUB     AL, '+'
        JNZ     @@CaseComma
        INC     SI
        INC     SI
        RET
  @@CaseComma:
;       CMP     AL, ','                 ; input byte
        DEC     AX
        JNZ     @@CaseMinus

;       LEA     BX, BF_InputSymbol
        MOV     BL, (offset BF_InputSymbol - 100h)
        MOV     CL, BF_InputSymbolSize
        JMP     MoveData                ; call, then ret
  @@CaseMinus:
;       CMP     AL, '-'                 ; decrease byte
        DEC     AX
        JNZ     @@CaseDot
;       MOV     word ptr [SI], 00DFEh   ; opcode for "DEC byte ptr [DI]"
        INC     SI                      ; FE05h + 08h = FE0Dh
        JMP     @@Add08IncSiRet         ; save some bytes of code
  @@CaseDot:
;       CMP     AL, '.'                 ; output byte
        DEC     AX
        JNZ     @@CaseLeft

;       LEA     BX, BF_OutputSymbol
        MOV     BL, (offset BF_OutputSymbol - 100h)
        MOV     CL, BF_OutputSymbolSize
  
  ; Moves CX bytes from [DS:BX + 100h] to [DS:SI]
  ; Used as a global routine
  MoveData:
        MOV     BH, 01                  ; add BX, 0100h
      @@MoveLoop:
        MOV     AL, [BX]
        MOV     [SI], AL
        INC     BX
        INC     SI
        LOOP    @@MoveLoop
        RET
  @@CaseLeft:
;       CMP     AL, '['
        CMP     AL, '[' - '.'
        JNE     @@CaseRight
        
        ; initialize WHILE loop
;       LEA     BX, BF_WhileLoop
        MOV     BL, (offset BF_WhileLoop - 100h)
        MOV     CL, BF_WhileLoopSize
        CALL    MoveData
        
        ; add two empty bytes for fix-up
        PUSH    SI
        INC     SI
        INC     SI

        ; compile statement list
        CALL    StatementList

        ; perform fix-up
        POP     BX
        LEA     AX, [SI - 2]
        SUB     AX, BX
        MOV     [BX], AX
  @@Ignore:
        RET
  @@CaseRight:
;       CMP     AL, ']'
        CMP     AL, ']' - '.'
        JNE     @@Ignore                ; treat character as comment
        POP     AX                      ; force WHILE loop to break

@@AfterLoop:
        MOV     byte ptr [SI], 0C3h     ; RET opcode
        INC     SI
        RET

StatementList endp

;       org     07F00h
;Buffer label   byte
        
        end     Start
