
;******************************************************}
;                                                      }
;       Brainf*ck compiler include file                }
;       Written by Y [24-01-03], [26-01-03]            }
;                                                      }
;       Copyright (c) 2003 YALLIE, Inc.                }
;       All Rights Reserved                            }
;                                                      }
;******************************************************}

; Some fragments of Brainf*ck program and compiler
; Written by Y [24-01-03] 

BF_InitProgramSize = BF_EndOfInitProgram - BF_InitProgram
BF_WhileLoopSize = BF_EndOfWhileLoop - BF_WhileLoop
BF_InputSymbolSize = BF_EndOfInputSymbol - BF_InputSymbol
BF_OutputSymbolSize = BF_EndOfOutputSymbol - BF_OutputSymbol

; Initialize the BF virtual machine:
; DS = ES, DI is the pointer, Buffer is clean

Initialize macro
  BF_InitProgram:
;       PUSH    DS              ; DOS startup conditions:
;       POP     ES              ;  ES = DS = CS
;       CLD                     ;  DF = 0

      IFDEF UPX_SAFE
        XOR     AX, AX          ; Packers like UPX don't take care of this:(
;       XOR     BX, BX          ;  AX = BX = 0
      ENDIF

;       LEA     DI, [Buffer]
;       MOV     CX, DI
        MOV     CH, 07Eh        ; CX = 7E00h-7EFFh (32256-32511)
        MOV     DI, CX          ; any value won't harm the stack
        PUSH    DI
        REP     STOSB           ; CX = 0 after this
        POP     DI
  BF_EndOfInitProgram:
        endm

; BF: ,

InputSymbol macro
  BF_InputSymbol:
        MOV     AH, 3Fh         ; read from file
        XOR     BX, BX          ; stdin
        MOV     CL, 1           ; # of bytes
        MOV     DX, DI          ; ds:dx -> buffer
        MOV     [DI], BL
        INT     21h             ; read
  BF_EndOfInputSymbol:
        endm

; BF: .

OutputSymbol macro
  BF_OutputSymbol:
        ; DOS function 02h (display single char) cannot
        ; be used here because it converts tabs to spaces
        MOV     AH, 40h         ; write to file
        MOV     CL, 1           ; # of bytes (ch = 0)
        MOV     BX, CX          ; stdout
        MOV     DX, DI          ; ds:dx -> buffer
        INT     21h             ; write
  BF_EndOfOutputSymbol:
        endm

; BF: [

; WhileLoop looks quite ugly, but it allows using RET for ] operation
; 16-bit Intel CPUs require conditional JMPs to be short

WhileLoop macro AfterLoop
  BF_WhileLoop:
        CMP     byte ptr [DI], CH
        JZ      BF_WhileLoopSkip
StatementList_Hack:
        CALL    BF_WhileLoopBody
        JMP     BF_WhileLoop
  BF_WhileLoopSkip:
        DB      0E9h            ; JMP AfterLoop
  BF_EndOfWhileLoop:
        DW      AfterLoop - BF_WhileLoopBody
  BF_WhileLoopBody:
        endm

